        ; String out is a test routine to get a string coded into the
        ; Eprom and output it to the display device used.
        ; Tom Riggs  1-21-94
          .ORG 0000H
START:     AJMP BEGIN
          .ORG 0020H
BEGIN:     MOV DPTR,#SET        ; Point Data Pointer to the first byte
           ACALL GETCHAR        ; of the string.
           MOV DPTR,#READY
           ACALL GETCHAR        ; R7 holds the length of the string.
STOP:      NOP                  ; Stop here.
           AJMP STOP
GETCHAR:   CLR A                ; Get characters stored in the eprom    
           MOVC A,@A+DPTR       ; use MOVC 'move code' to get bytes 
           MOV R7,A             ; the first byte is length of string.
CHARLP     CLR A                ; accum. must be cleared to keep
           INC DPTR             ; true point to data.
           MOVC A,@A+DPTR       ; DPTR data pointer is easier to
           ACALL CHAROUT        ; increment.
           DJNZ R7,CHARLP       ; The character is then passed to the
           RET                  ; output routine. 
CHAROUT:   NOP                  ; modify charout for display type
           NOP                  ; either lcd or other test board.
           RET

READY     .BYTE   7H," READY "            ; Sample strings.       
SET       .BYTE   7H," RESET "
STRG      .BYTE   16H,"8031 MICROCONTROLLER",10,13
STG2      .BYTE   12H,"SERIAL PORT TEST",10,13  
LCDTST    .BYTE   0EH," 8031 LCD TEST"
TOPLN     .BYTE   0AH,"     8031"              ; 2-line LCD
BOTLN     .BYTE   0FH,"MICROCONTROLLER"        ; " "   "  "
.END 
